
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Panel;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;

import javax.swing.JLabel;

class JImagePanel extends Panel{
	/**
	 * 
	 */
	private static final long serialVersionUID = 5375994938523354306L;
	private  MediaTracker tracker;
	MainFenetre action ; 
	private Image img;
	private Dimension imgSize,iniSize;
	private int zoom = 0 ;
	private int	MouseX;
	private int	MouseY;
	int transX=0;
	int transY=0;

	public JImagePanel(String file){
		//setSize(100,200);
		tracker=new MediaTracker(this);
	
		img=Toolkit.getDefaultToolkit().getImage(file);

	
		
		//myObjet obj = new myObjet("source",0.002);
		tracker.addImage(img,0);
	
		setLayout(null);
		//obj.setBounds(400,400, 100, 100);
		//add(obj);
	// System.out.println("X : " + obj.getX() + "," + "Y : " + obj.getY());

		
		addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				MouseX = e.getX();
				MouseY = e.getY();
			}
		});

		addMouseMotionListener(new MouseMotionAdapter() {
			@Override
			public void mouseDragged(MouseEvent e) {
			
				transX += e.getX()-MouseX;
				transY += e.getY()-MouseY;
				MouseX = e.getX();
				MouseY = e.getY();
			
				//	System.err.println("Translate : "+transX+", "+transY);
				repaint();
		
			}
		});

		try{
			tracker.waitForAll();
		}
		catch(Exception ie){}
		imgSize=iniSize=new Dimension(img.getWidth(this),img.getHeight(this));
	}

	

	public Dimension getPreferredSize(){
		return new Dimension(imgSize);
	}

	public void paint(Graphics g){
		super.paint(g);
		if(imgSize.width<=iniSize.width) {
			imgSize=iniSize; 
		}
		
		g.drawImage(this.img, (getWidth()-imgSize.width)/2+transX, (getHeight()-imgSize.height)/2+transY, imgSize.width,imgSize.height,this);
	}
	public void zoomIn(){
		int x=10*imgSize.width/100; 
		int y=10*imgSize.height/100;
		imgSize=new Dimension(imgSize.width+x,imgSize.height+y); 
		if(imgSize.width>iniSize.width){
			setSize(imgSize);
			getParent().doLayout();
		}
		repaint();
	}
	public void zoomOut(){
		int x=10*imgSize.width/100;
		int y=10*imgSize.height/100;
		imgSize=new Dimension(imgSize.width-x,imgSize.height-y);
		if(getWidth()>iniSize.width)
		{
			setSize(imgSize);
			getParent().doLayout();
		}
		repaint();
	}

	public int getZoom() {
		return zoom;
	}

	public void setZoom(int zoom) {
		this.zoom = zoom;
	}
	public void setlabel (String s )
	{
		JLabel lnl = new JLabel(s);
		add(lnl);
		return ;
	}



}









